// No need to make this an object, but it's safer to avoid possible duplicate function names
var pasteip = {
	init: function() {
		var menu = document.getElementById('contentAreaContextMenu');
		menu.addEventListener('popupshowing', pasteip.showHide, false);
	},

// Instead of setting up complex checking for a textbox, let's just show the items if the "Undo" item is shown
	showHide: function() {
		document.getElementById('context-pasteip').hidden = document.getElementById('context-undo').hidden;
		document.getElementById('context-pasteua').hidden = document.getElementById('context-undo').hidden;
	},

// Thanks to mozillazine forum user Torisugari for pointing me to this XPCOM interface as an alternative to using Java!
	pasteAddress: function(isMail) {
		var DNSService=Components.classes["@mozilla.org/network/dns-service;1"].getService(Components.interfaces.nsIDNSService);
// After 11 September we can't get the IP address directly
//		var theAddress = DNSService.myIPAddress;
// So we'll get the hostname and resolve it.
		var DNSRecord=DNSService.resolve(DNSService.myHostName, true);
// This may return more than one IP, so load them into an array
		allIP = new Array(1);
		for (i=0;DNSRecord.hasMore();i++) allIP[i]=DNSRecord.getNextAddrAsString();
// Then check prefs to see which one to put in the textbox
		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		if (preferencesService.prefHasUserValue("pasteip.ipaddress.select")) {
			whichIP = preferencesService.getIntPref("pasteip.ipaddress.select");
		}
		else {
			whichIP = 0;
		}
// Make sure nobody puts a stupid value in the pref
		var theAddress=(whichIP < allIP.length)?allIP[whichIP]:allIP[0];
// Make the change
		if (isMail == 1) {
			theEditor = GetCurrentEditor();
  			if (theEditor) theEditor.insertText(theAddress);
		}
		else {
			var theBox = document.commandDispatcher.focusedElement;
			theBox.value = theBox.value + theAddress;
		}
	},

	pasteUA: function(isMail) {
		var ua = navigator.userAgent;
		if (isMail == 1) {
			theEditor = GetCurrentEditor();
  			if (theEditor) theEditor.insertText(ua);
		}
		else {
			var theBox = document.commandDispatcher.focusedElement;
			theBox.value = theBox.value + ua;
		}
	}
}
window.addEventListener('load', pasteip.init, false); 
